{---------------------------------------------------------------}
{   Program  : Testing motor stepper 5 phase                    }
{   Oleh     : David Setya Atmaja (DSA)                         }
{   Dibuat   : 31 Desember 2003                                 }
{   Adaptasi : dari program Douglas W. Jones                    }
{---------------------------------------------------------------}
USES
    DOS, CRT;

TYPE
    LPT_Port   = (LPT_1, LPT_2, LPT_3, No_LPT);
    String2    = STRING[2];

CONST
     Ada_Card  : BOOLEAN = FALSE;
     Ada_LPT   : BOOLEAN = FALSE;
     Bi_Direct : BOOLEAN = FALSE;
     Batal     : BOOLEAN = FALSE;
     DP        : ARRAY[LPT_Port] OF WORD = ($3BC, $278, $378, $3BC); { Data Port }
     PS        : ARRAY[LPT_Port] OF WORD = ($3BD, $279, $379, $3BD); { Status Port }
     PC        : ARRAY[LPT_Port] OF WORD = ($3BE, $27A, $37A, $3BE); { Control Port }
     MaxStep   = 9;
     Steps     = 10;

VAR
   Temp_DP     : BYTE;
   Temp_PC     : BYTE;
   CH          : CHAR;
   LPT         : LPT_Port;
   StepTab     : ARRAY [0..MaxStep] OF INTEGER;
   Step        : INTEGER;
   Direction   : INTEGER;
   Regs        : REGISTERS;

PROCEDURE Tombol;
BEGIN
     CH := UPCASE(READKEY);
     IF CH = #0 THEN
     BEGIN
          CH := READKEY;CH := 'D';
     END;
END;

FUNCTION Hex2Str(Angka : WORD) : String2;
CONST
     HexDigit : ARRAY[0..15] OF CHAR = '0123456789ABCDEF';
VAR
   I : BYTE;
BEGIN
     Hex2Str[0] := #2;
     FOR I := 2 DOWNTO 1 DO
     BEGIN
          Hex2Str[I] := HexDigit[Angka AND $F];
          Angka := Angka SHR 4;
     END;
END;

PROCEDURE Cek_LPT_Port;
BEGIN
     FOR LPT := LPT_1 TO LPT_3 DO
     BEGIN
          Ada_LPT := FALSE;Bi_Direct := FALSE;
          IF PORT[PC[LPT]] <> $FF THEN Ada_LPT := TRUE;    { Check LPT Adapter port }
          IF Ada_LPT THEN
          BEGIN
               Ada_Card := TRUE;                 { LPT Adapter Card found }
               Temp_DP := PORT[DP[LPT]];
               PORT[DP[LPT]] := $C9;
               Temp_PC := PORT[PC[LPT]];
               PORT[PC[LPT]] := Temp_PC OR $20;  { Check bi-directional port }
               IF PORT[DP[LPT]] <> $C9 THEN Bi_Direct := TRUE;
               PORT[PC[LPT]] := Temp_PC;
               PORT[DP[LPT]] := Temp_DP;
               WRITE('LPT adapter port no. $',Hex2Str(HI(DP[LPT])),Hex2Str(LO(DP[LPT])),' is = ');
               IF Bi_Direct THEN WRITE('bi-directional')
               ELSE WRITE('standard');
               WRITELN(' port.');
               Tombol;
          END;
     END;
     IF NOT Ada_Card THEN
     BEGIN
          WRITELN('Printer Adapter Card not found in this computer ...');
          Tombol;
     END
     ELSE
     BEGIN
          WRITELN;
          REPEAT
                WRITE(#13,'Test LPT adapter port no. (1 or 2) ? ');
                READ(CH);
          UNTIL CH IN ['1','2',#27];
          CASE CH OF
               '1' : LPT := LPT_1;
               '2' : LPT := LPT_2;
               #27 : Batal := TRUE;
          END;
     END;
END;

PROCEDURE Init_Awal;
BEGIN
     Step := 0;
     StepTab[0] := 13; { binary 01101 }
     StepTab[1] := 9;  { binary 01001 }
     StepTab[2] := 11; { binary 01011 }
     StepTab[3] := 10; { binary 01010 }
     StepTab[4] := 26; { binary 11010 }
     StepTab[5] := 18; { binary 10010 }
     StepTab[6] := 22; { binary 10110 }
     StepTab[7] := 20; { binary 10100 }
     StepTab[8] := 21; { binary 10101 }
     StepTab[9] := 5;  { binary 00101 }
     IF (NOT Batal) AND Ada_Card THEN PORT[DP[LPT]] := StepTab[Step];
END;

PROCEDURE OneStep(Dir : INTEGER);
BEGIN
     Step := Step + Dir;
     IF Step > MaxStep THEN Step := 0
     ELSE IF Step < 0 THEN Step := MaxStep;
     IF (NOT Batal) AND Ada_Card THEN PORT[DP[LPT]] := StepTab[Step];
END;

PROCEDURE Tundaan_1S;
BEGIN
     Regs.CX := 0; { 0 = Sebanding kira-kira 0,49 sekon }
     REPEAT
           REPEAT
                 Regs.AL := PORT[$61];      { Refresh tiap 15.085 uS }
                 Regs.AL := Regs.AL AND $10;{ PB_4 = ? }
           UNTIL Regs.AL <> Regs.AH;        { Tunggu sampai ganti }
           Regs.AH := Regs.AL;
           DEC(Regs.CX);                    { Loop sampai zero }
     UNTIL Regs.CX = 0;
END;

BEGIN
     CLRSCR;
     WRITELN('5-Phase Stepper Motor Tester, Ver 1.10');
     WRITELN('(C) 31 Dec, 2003, by: David Setya Atmaja (DSA)');
     WRITELN;
     Cek_LPT_Port;
     Init_Awal;
     IF (NOT Batal) AND Ada_Card THEN
     BEGIN
          WRITELN;
          WRITELN('Running the motor .....');
          WRITELN;
          WRITELN('Press ''F'' to Forward, ''R'' to Reverse or ''<Esc>'' key to Exit ...');
          WRITELN;
          REPEAT
                IF KEYPRESSED THEN
                BEGIN
                     CH := UPCASE(READKEY);
                     CASE CH OF
                          'F' : BEGIN
                                     Direction := 1;
                                     WRITELN('Motor now Forward!');
                                END;
                          'R' : BEGIN
                                     Direction := -1;
                                     WRITELN('Motor now Reverse!');
                                END;
                          #27 : BEGIN
                                     Batal := TRUE;
                                     WRITELN('Exit now .....');
                                END;
                     END;
                END;
                OneStep(Direction);
                Tundaan_1S;
          UNTIL Batal;
     END;
END.
